﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SchedulerApp1
{
    public class MainViewModel
    {
        public ObservableCollection<MyAppointment> Appointments { get; private set; }

        public async Task LoadAppointments()
        {

            List<MyAppointment> appointments = await ScheduleDataStorage.LoadAppointmentsAsync();
            this.Appointments = new ObservableCollection<MyAppointment>();
            foreach (MyAppointment a in appointments)
            {
                this.Appointments.Add(a);
            }
        }

        public async Task SaveAppointments()
        {
            List<MyAppointment> appointments = new List<MyAppointment>();
            foreach (MyAppointment a in this.Appointments)
            {
                appointments.Add(a);
            }
            await ScheduleDataStorage.SaveAppointments(appointments);
        }

        public MainViewModel()
        {
            // create sample appointment
            Appointments = new ObservableCollection<MyAppointment>();
            Appointments.Add(new MyAppointment { Subject = "New Appointment", Start = DateTime.Now, End = DateTime.Now.AddHours(1) });
        }
    }
}
