﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;
using System.IO;
using Windows.Storage.Streams;

namespace SchedulerApp1
{
    public static class ScheduleDataStorage
    {
        public static async Task<List<MyAppointment>> LoadAppointmentsAsync()
        {
            string _filename = "appointments.xml";
            List<MyAppointment> appointments = new List<MyAppointment>();
            XmlRootAttribute root = new XmlRootAttribute("Appointments");
            System.Xml.Serialization.XmlSerializer serializer = new XmlSerializer(appointments.GetType(), root);

            var folder = Windows.Storage.ApplicationData.Current.LocalFolder;
            var file = await folder.CreateFileAsync(_filename, Windows.Storage.CreationCollisionOption.OpenIfExists);
            IRandomAccessStream stream = await file.OpenAsync(Windows.Storage.FileAccessMode.Read);

            try
            {
                appointments = serializer.Deserialize(stream.AsStreamForRead()) as List<MyAppointment>;
            }
            catch { }

            return appointments;

        }

        public static async Task SaveAppointments(List<MyAppointment> appointments)
        {
            string _filename = "appointments.xml";
            var folder = Windows.Storage.ApplicationData.Current.LocalFolder;
            var file = await folder.CreateFileAsync(_filename, Windows.Storage.CreationCollisionOption.OpenIfExists);
            XmlRootAttribute root = new XmlRootAttribute("Appointments");
            System.Xml.Serialization.XmlSerializer serializer = new System.Xml.Serialization.XmlSerializer(appointments.GetType(), root);
            IRandomAccessStream stream = await file.OpenAsync(Windows.Storage.FileAccessMode.ReadWrite);

            serializer.Serialize(stream.AsStreamForWrite(), appointments);
            await stream.FlushAsync();
            stream.Dispose();
        }
    }

}
